// Copyright Erkki Seppl 2002
// $Id: addressunix.hh,v 1.1 2003/01/26 19:40:39 flux Exp $
// $Author: flux $ 
// $Revision: 1.1 $


#ifndef ADDRESSUNIX_HH
#define ADDRESSUNIX_HH

#include <network/address.hh>
#include <sys/un.h>

namespace Network {
  class AddressUnix: public Address {
  public:
    AddressUnix();
    AddressUnix(const Address& a_address);
    AddressUnix(const AddressUnix& a_address);
    explicit AddressUnix(std::string a_path);
    virtual ~AddressUnix();

    std::string	getPath() const;

    void setPath(std::string a_path);

    /// Unlinks the address from the filesystem
    void unlink() const;

    static int getProtocol();

  private:
    class InterfaceUnix;
    friend class InterfaceUnix;
    class HelperUnix;
    friend class HelperUnix;
  };
}

#endif // ADDRESSUNIX_HH


// changelog:
//
// $Log: addressunix.hh,v $
// Revision 1.1  2003/01/26 19:40:39  flux
// Added some files (had to revert an old repository from backups)
//
// Revision 1.2  2002/07/02 19:54:47  flux
// Added unlink-method to AddressUnix
//
// Revision 1.1  2002/07/02 19:41:07  flux
// Added Unix-addresses
//
