// Copyright Erkki Seppl 2002
// $Id: error.cc,v 1.3 2002/05/28 14:55:04 flux Exp $
// $Author: flux $ 
// $Revision: 1.3 $

static char* gs_id __attribute__ ((unused)) ="$Id: error.cc,v 1.3 2002/05/28 14:55:04 flux Exp $"; /// ID for CVS/RCS

#include <network/error.hh>
#include <network/exception.hh>

namespace Network {
  static
  void
  defaultErrorHandler(ErrorClass a_errorClass, std::string a_message)
  {
    switch (a_errorClass) {
    case ERROR_NONE: ;
    case ERROR_RESOLVE: throw ResolverException(a_message);
    case ERROR_FAMILY: throw FamilyException(a_message);
    }
  }

  static ErrorHandler gs_errorHandler = defaultErrorHandler;

  ErrorHandler
  setErrorHandler(ErrorHandler a_handler)
  {
    ErrorHandler oldHandler = gs_errorHandler;
    gs_errorHandler = a_handler;
    return oldHandler;
  }

  void
  error(ErrorClass a_errorClass, std::string a_message)
  {
    gs_errorHandler(a_errorClass, a_message);
  }
}

// changelog:
//
// $Log: error.cc,v $
// Revision 1.3  2002/05/28 14:55:04  flux
// Updated copyright message
//
// Revision 1.2  2002/05/22 07:03:04  flux
// Added error-handling.
// Added casting.
// Added type checking method.
//
// Revision 1.1  2002/05/22 06:33:43  flux
// First version
//
