// Copyright Erkki Seppl 2002
// $Id: error.hh,v 1.3 2002/05/28 14:55:04 flux Exp $
// $Author: flux $ 
// $Revision: 1.3 $


#ifndef ERROR_HH
#define ERROR_HH

#include <string>

namespace Network {
  enum ErrorClass {
    ERROR_NONE,
    ERROR_RESOLVE,
    ERROR_FAMILY
  };

  typedef void (*ErrorHandler)(ErrorClass a_errorClass, std::string message);

  ErrorHandler setErrorHandler(ErrorHandler a_handler);
  
  void error(ErrorClass a_errorClass, std::string message) __attribute__ ((noreturn));
}

#endif // ERROR_HH


// changelog:
//
// $Log: error.hh,v $
// Revision 1.3  2002/05/28 14:55:04  flux
// Updated copyright message
//
// Revision 1.2  2002/05/22 07:03:04  flux
// Added error-handling.
// Added casting.
// Added type checking method.
//
// Revision 1.1  2002/05/22 06:33:43  flux
// First version
//
