// Copyright Erkki Seppl 2002
// $Id: exception.cc,v 1.4 2003/01/26 19:42:34 flux Exp $
// $Author: flux $ 
// $Revision: 1.4 $

static char* gs_id __attribute__ ((unused)) ="$Id: exception.cc,v 1.4 2003/01/26 19:42:34 flux Exp $"; /// ID for CVS/RCS

#include <network/exception.hh>

namespace Network {
  Exception::Exception(std::string a_message) :
    m_message(a_message)
  {
    // nothing
  }

  Exception::~Exception() throw()
  {
    // nothing
  }

  const char*
  Exception::what() const throw()
  {
    return m_message.c_str();
  }
    

  ResolverException::ResolverException(std::string a_message) :
    Exception(a_message)
  {
    // nothing
  }

  FamilyException::FamilyException(std::string a_message) :
    Exception(a_message)
  {
    // nothing
  }
}


// changelog:
//
// $Log: exception.cc,v $
// Revision 1.4  2003/01/26 19:42:34  flux
// Fixed c++ standard version bugs older gcc hadn't noticed
//
// Revision 1.3  2002/05/28 14:55:04  flux
// Updated copyright message
//
// Revision 1.2  2002/05/22 07:03:04  flux
// Added error-handling.
// Added casting.
// Added type checking method.
//
// Revision 1.1  2002/05/22 06:33:43  flux
// First version
//
