// Copyright Erkki Seppl 2002
// $Id: exception.hh,v 1.4 2003/01/26 19:42:34 flux Exp $
// $Author: flux $ 
// $Revision: 1.4 $


#ifndef EXCEPTION_HH
#define EXCEPTION_HH

#include <string>
#include <exception>

namespace Network {
  class Exception: public std::exception {
  public:
    Exception(std::string a_message);
    virtual ~Exception() throw ();

    const char* what() const throw ();

  private:
    std::string		m_message;
  };

  class ResolverException: public Exception {
  public:
    ResolverException(std::string a_message);
  };

  class FamilyException: public Exception {
  public:
    FamilyException(std::string a_message);
  };
}
  
#endif // EXCEPTION_HH


// changelog:
//
// $Log: exception.hh,v $
// Revision 1.4  2003/01/26 19:42:34  flux
// Fixed c++ standard version bugs older gcc hadn't noticed
//
// Revision 1.3  2002/05/28 14:55:04  flux
// Updated copyright message
//
// Revision 1.2  2002/05/22 07:03:05  flux
// Added error-handling.
// Added casting.
// Added type checking method.
//
// Revision 1.1  2002/05/22 06:33:43  flux
// First version
//
