// Copyright Erkki Seppl 2002
// $Id: nh.hh,v 1.2 2002/05/28 14:55:04 flux Exp $
// $Author: flux $ 
// $Revision: 1.2 $


#ifndef NH_HH
#define NH_HH

#include <sys/types.h>
#include <netinet/in.h>

namespace Network {
#ifdef NETWORK_LONGLONG
#ifdef BIGENDIAN
  inline u_int64_t
  htonll(u_int64_t hostlonglong)
  {
    return (((unsigned long long) ((hostlonglong >>  0) & 0xff) << 56) |
            ((unsigned long long) ((hostlonglong >>  8) & 0xff) << 48) |
            ((unsigned long long) ((hostlonglong >> 16) & 0xff) << 40) |
            ((unsigned long long) ((hostlonglong >> 24) & 0xff) << 32) |
            ((unsigned long long) ((hostlonglong >> 32) & 0xff) << 24) |
            ((unsigned long long) ((hostlonglong >> 40) & 0xff) << 16) |
            ((unsigned long long) ((hostlonglong >> 48) & 0xff) <<  8) |
            ((unsigned long long) ((hostlonglong >> 56) & 0xff) <<  0)
            );
  }

#endif // BIGENDIAN

#ifdef LITTLEENDIAN
  inline u_int64_t
  htonll(u_int64_t hostlonglong)
  {
    return hostlonglong;
  }
#endif // LITTLEENDIAN

  inline unsigned long long
  ntohll(unsigned long long hostlonglong)
  {
    return htonll(hostlonglong);
  }
#endif // NETWORK_LONGLONG

  // modifies the target so we don't use immediates here
  inline void ntoh(u_int8_t& i, u_int8_t j) { i = j; }
  inline void hton(u_int8_t& i, u_int8_t j) { i = j; }
  inline void ntoh(u_int16_t& i, u_int16_t j) { i = ntohs(j); }
  inline void hton(u_int16_t& i, u_int16_t j) { i = htons(j); }
  inline void ntoh(u_int32_t& i, u_int32_t j) { i = ntohl(j); }
  inline void hton(u_int32_t& i, u_int32_t j) { i = htonl(j); }

#ifdef NETWORK_LONGLONG
  inline void ntoh(u_int64_t& i, u_int64_t j) { i = ntohll(j); }
  inline void hton(u_int64_t& i, u_int64_t j) { i = htonll(j); }
#endif // NETWORK_LONGLONG
}

#endif // NH_HH


// changelog:
//
// $Log: nh.hh,v $
// Revision 1.2  2002/05/28 14:55:04  flux
// Updated copyright message
//
// Revision 1.1  2002/05/28 14:54:27  flux
// Added network/host-conversions
//
