// Copyright Erkki Seppl 2002
// $Id: stream.hh,v 1.4 2003/01/26 19:42:34 flux Exp $
// $Author: flux $ 
// $Revision: 1.4 $


#ifndef STREAM_HH
#define STREAM_HH

#include <iostream>
#include <memory>

namespace Network {
  class StreamBuf: public std::streambuf {
  public:
    StreamBuf(int a_fd);
    ~StreamBuf();

    int overflow(int c);
    int underflow();
    int uflow();
    int sync();

    int getFd() const;
    
  private:
    int		m_fd;
    char	m_readBuffer[1024];
    char	m_writeBuffer[1024];
  };
  
  class Stream: public std::iostream {
  public:
    Stream(int a_fd);
    virtual ~Stream();

    void disconnect();
    
  private:
    Stream(const Stream& a_other); /// not there
    Stream& operator=(const Stream& a_other); /// not there
    
  };
}

#endif // STREAM_HH


// changelog:
//
// $Log: stream.hh,v $
// Revision 1.4  2003/01/26 19:42:34  flux
// Fixed c++ standard version bugs older gcc hadn't noticed
//
// Revision 1.3  2002/05/28 14:55:04  flux
// Updated copyright message
//
// Revision 1.2  2002/05/28 07:47:16  flux
// Added actual stream code.
// Added Stream::disconnect
//
// Revision 1.1  2002/05/22 08:33:29  flux
// Added some Socket-wrapping
//
